package com.huiju.welcome.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 字典表
 * </p>
 *
 * @author jobob
 * @since 2019-07-16
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class SysDict implements Serializable {

    private static final long serialVersionUID = 1L;
    
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;
    
    private String label;

    private String value;

    private Integer dictPid;

    private String dictParents;

    /**
     * 1:意向房型      ROOM_TYPE
     * 2:意向等级      GRADE
     * 3:来访目的      VISIT_PURPOSE
     * 4:来访渠道      VISIT_CHANNEL
     * 5:来访人数      NUMBER_OF_VISITORS
     * 6:客户年龄      CUSTOMER_AGE
     * 7:现居住区域    RESIDENTIAL_AREA
     * 8:工作行业      WORK_INDUSTRY
     * 9:工作职务      WORK_DUTY
     * 10:置业次数     NUMBER_OF_HOME_PURCHASES
     * 11:名下房产数量 NUMBER_OF_PROPERTIES
     * 12:现居住面积   LIVING_AREA
     * 13:现住户型     RESIDENTIAL_UNIT
     * 14:目前家庭结构 FAMILY_STRUCTURE
     */
    private String type;

    private Integer sort;

    private Integer status;

    private LocalDateTime createDate;


}
